unit HotAnAdv;

interface

uses
{$ifdef WIN32}
	Windows,
{$else}
	WinTypes, WinProcs,
{$endif}
	Messages, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, HotAn104;

const
{$ifdef WIN32}
	DLLName = '..\MakeDLL\ImgDLL32.DLL';
{$else}
	DLLName = '..\MakeDLL\ImgDLL16.DLL';
{$endif}

type
	TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    HotAnimFX1: THotAnimFX;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
		procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
		procedure HotAnimFX1HotspotClick(Sender: TObject; const HotspotName: String);
    procedure FormCreate(Sender: TObject);
		procedure HotAnimFX1AnimComplete(Sender: TObject);
	private
		Toggle, Cancelled: Boolean;
		procedure ClearAnimation;
	public
    { Public declarations }
	end;

const
	StopText = 'Stop';
var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Caption = StopText then
	begin
		HotAnimFX1.StopAnim;
		HotAnimFX1.StopEffect;
    Cancelled := True;
		Button1.Caption := 'Effects';
		Button2.Enabled := True;
		HotAnimFX1.Invalidate;
	end else
	begin
		Button1.Caption := StopText;
		Button2.Enabled := False;
    Cancelled := False;

		while not Cancelled do
    begin
			Toggle := not Toggle;

			if Toggle then
				HotAnimFX1.LoadBitmapFromFile('..\MakeDLL\Earth.bmp')
			else
				HotAnimFX1.LoadBitmapFromFile('..\MakeDLL\Shipping.bmp');

			HotAnimFX1.ShowEffect;
			while HotAnimFX1.Busy do
			begin
				if Cancelled then break;		{Allows FormCloseQuery below to shut down this loop and the outer "while" so...}
				Application.ProcessMessages;	{...the app can close}
			end;

			if HotAnimFX1.Effect = fxPushUp then
				HotAnimFX1.Effect := fxNone
			else
				HotAnimFX1.Effect := Succ(HotAnimFX1.Effect);
		end;
	end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
	if (Button2.Caption = StopText) then
		ClearAnimation
	else
	begin
		HotAnimFX1.LoadBitmapFromFile('..\MakeDLL\AcroLogo.bmp');	{To load from disk--resource name does not have path info}
		HotAnimFX1.LoadSpriteFromFile('..\MakeDLL\FlyBy.bmp');	{Ditto}

		{This loads the logo bitmap from ACROLOGO_BMP resource bitmap
		in the ImgDLL16/32.DLL ImageSet. If the ImageSet is not loaded
		in FormCreate, the bitmap will automatically be loaded from the
		file (not the DLL), if the file exists.}
{		HotAnimFX1.BitmapName := 'AcroLogo.bmp';		{Loads from DLL}
{		HotAnimFX1.SpriteName := 'FlyBy01.bmp';
}		Button2.Caption := StopText;
		Button1.Enabled := False;
		HotAnimFX1.StartAnim;
	end;
end;

procedure TForm1.ClearAnimation;
begin
		HotAnimFX1.StopAnim;
		Button1.Enabled := True;
		Button2.Caption := 'Animate';
		HotAnimFX1.ClearSprite;
end;

{This stops any loop in process and halts Animation or Effects timers so the form can close.}
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
	HotAnimFX1.StopAnim;

	HotAnimFX1.StopEffect;

	Cancelled := True;
end;

procedure TForm1.HotAnimFX1HotspotClick(Sender: TObject; const HotspotName: String);
begin
	{This loads the logo bitmap from ACROLOGO_BMP resource bitmap
	in the ImgDLL16/32.DLL ImageSet. If the ImageSet is not loaded
	in FormCreate, the bitmap will be loaded from the file automatically.
	(if the file exists, of course)}
	HotAnimFX1.BitmapName := 'AcroLogo.bmp';
	ShowMessage('You clicked ' + HotspotName);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	HotAnimFX1.LoadImageSet(DLLName);	{DLLName is a predefined constant; see top of file}
end;

procedure TForm1.HotAnimFX1AnimComplete(Sender: TObject);
begin
	ClearAnimation;
end;

end.
